﻿Type=Class
Version=3
@EndOfDesignText@
'ComboBox Class module V 1.4
#Event: ItemClick(Position As Int, Item As String)
#RaisesSynchronousEvents: lblItem_Click

Sub Class_Globals
	Private cCallbackModule As Object
	Private cEventName As String
	Private cParent As Panel
	Private cActivity As Activity

	Private lblLeft, lblTop, lblWidth, lblHeight, itemHeight As Int
	Private itemLeft, itemWidth, itemHeight_1 As Int
	Private lblComboBox As Label
	Private scvComboBox As ScrollView
	Private lstComboBox As List 

	Private cSelectedIndex = -1 As Int
	Private cSelectedItem = "" As String
	
	Private cItemColor = Colors.RGB(60, 60, 60) As Int
	Private cBackgroundColor = Colors.Gray As Int
	Private cSelectedItemColor = Colors.Cyan As Int
	Private cTextSize = 16 As Float
	Private cTextColor = Colors.White As Int
	Private cSelectedTextColor = Colors.Black As Int
'	Private cBoarderWidth = 2dip As Int
	Private cBoarderWidth = 1 As Int
	Private cNumberVisibleItems = 6 As Int
	Private cMultiSelect = False As Boolean
	Public MultiSelectList As List
	Private cMaxNumberOfSelections As Int
	Private cbxBackground As Object
	Private pnlScreen As Panel
End Sub

'Initializes the object. You can add parameters to this method if needed.
'CallbackModule = calling module mostly Me
'Parent = parent view Activity
Public Sub Initialize(CallbackModule As Object, EventName As String)
	cCallbackModule = CallbackModule
	cEventName = EventName
End Sub

'This routine is used by the Designer if you add the ComboBox in the Designer
Public Sub DesignerCreateView(Base As Panel, lbl As Label, Props As Map)
	lblLeft = Base.Left
	lblTop = Base.Top
	lblWidth = Base.Width
	lblHeight = Base.Height

	cTextSize = lbl.TextSize

	cActivity = Props.Get("activity")
	
	GetParent2(Base)
	
	Base.RemoveView
	
	Init
End Sub

'This routine is needed if you want to add the ComboBox view in the code.
'Parent = parent view, can be a Panel or the Activity
'Left, Top, Width and Height properties of the ComboBox
'Example: 
'<Code>ComboBox1.Initialize(Me, "ComboBox1")
'ComboBox1.Show(Activity, 20dip, 20dip, 150dip, 48dip)</Code>
Public Sub Show(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int)
 	lblLeft = Left
	lblTop = Top
	lblWidth = Width
	lblHeight = Height

	Dim lv As LayoutValues
	lv = GetDeviceLayoutValues
	cTextSize = lblHeight / 2 / lv.Scale
	
	cParent = Parent
	
	GetParent1(cParent)
	
	Init
End Sub

'Internal routine to initialize the ComboBox.
Private Sub Init
	Dim spn As Spinner
	spn.Initialize("")
	cParent.AddView(spn, 0, -500dip, 100dip, 50dip)
	Dim jobj = spn As JavaObject
	cbxBackground = jobj.RunMethod("getBackground", Null)
	spn.RemoveView
	
	lblComboBox.Initialize("")
	cParent.AddView(lblComboBox, lblLeft, lblTop, lblWidth, lblHeight)

	lblComboBox.Background = cbxBackground
	SetPadding(lblComboBox, cTextSize *100dip / 100, 1dip, 2dip, 1dip)
	
	lblComboBox.Gravity = Gravity.CENTER_VERTICAL
	lblComboBox.TextSize = cTextSize
	lblComboBox.TextColor = cTextColor
	
	Dim r1 As Reflector
	r1.Target = lblComboBox
	r1.SetOnTouchListener("lblComboBox_Touch")
	
	lstComboBox.Initialize
	MultiSelectList.Initialize
End Sub

Private Sub GetParent2(v As View)
	Dim Parent As View
	
	Dim jobj = v As JavaObject

	Parent = jobj.RunMethod("getParent", Null)
	If Parent Is Panel Then
		cParent = Parent
	Else
		cParent = cActivity
	End If
End Sub

Private Sub GetParent1(v As View)
	Dim Parent As View
	
	Dim jobj = v As JavaObject
	
	Parent = jobj.RunMethod("getParent", Null)
	If Parent Is Activity Then
		cActivity = Parent
	Else
		cActivity = cParent
	End If
End Sub

Private Sub GetParent(v As Object) As Object
	Dim jobj = v As JavaObject
	Return jobj.RunMethod("getParent", Null)
End Sub

Private Sub GetParentsLeft(v As View) As Int
	Dim Left = 0 As Int
	Dim v1 As View
	
	v1 = v
	If GetType(GetParent(v1)) = "android.widget.FrameLayout" Then 
		Return 0
	End If
	
	Try
		Left = v1.Left
	Catch
		Log(LastException.Message)
	End Try
	v1 = GetParent(v1)
	Do While v1 <> cActivity
		Try
			Left = Left + v1.Left
		Catch
			Log(LastException.Message)
		End Try
		v1 = GetParent(v1)
	Loop
	Return Left
End Sub

Private Sub GetParentsTop(v As View) As Int
	Dim Top = 0 As Int
	Dim v1 As View
	
	v1 = v
	If GetType(GetParent(v1)) = "android.widget.FrameLayout" Then 
		Return 0
	End If
	Try
		Top = v1.Top
	Catch
		Log(LastException.Message)
	End Try
	v1 = GetParent(v1)
	Do While v1 <> cActivity
		Try
			Top = Top + v1.Top
			If GetType(v1) = "anywheresoftware.b4a.objects.ScrollViewWrapper$MyScrollView" Then
				Dim scv As ScrollView
				scv = v1
				Top = Top - scv.ScrollPosition
			End If
		Catch
			Log(LastException.Message)
		End Try
		v1 = GetParent(v1)
	Loop
	Return Top
End Sub

Private Sub SetPadding(v As View, Left As Int, Top As Int, Right As Int, Bottom As Int)
	Dim jobj = v As JavaObject
	jobj.RunMethod("setPadding", Array As Object(Left, Top, Right, Bottom))
End Sub

Sub lblItem_Click
	Dim t As Int
	
	If cMultiSelect = False Then
		Dim lbl As Label
		lbl = Sender
		lbl.TextColor = cSelectedTextColor
		lbl.Color = cSelectedItemColor
		
		cSelectedIndex = lbl.Tag
		cSelectedItem = lbl.Text
		lblComboBox.Text = lbl.Text
		scvComboBox.RemoveView
		pnlScreen.RemoveView
	Else
		Dim lbl As Label
		lbl = Sender
		t = lbl.Tag
		If lbl.TextColor = cSelectedTextColor Then
			lbl.TextColor = cTextColor
			lbl.Color = cItemColor
			MultiSelectList.RemoveAt(MultiSelectList.IndexOf(t))
		Else
			If MultiSelectList.Size = cMaxNumberOfSelections Then
				ToastMessageShow("No more selections allowed", False)
				Return
			End If
			MultiSelectList.Add(t)
			lbl.TextColor = cSelectedTextColor
			lbl.Color = cSelectedItemColor
			lblComboBox.Text = lbl.Text
		End If
	End If
	
	If SubExists(cCallbackModule, cEventName & "_ItemClick") Then
		t = lbl.Tag
		CallSub3(cCallbackModule, cEventName & "_ItemClick", t, lbl.Text)
	End If
End Sub

Private Sub pnlScreen_Click
	pnlScreen.RemoveView
End Sub

Private Sub lblComboBox_Touch (viewtag As Object, Action As Int, X As Float, Y As Float, motionevent As Object) As Boolean
	Select Action
	Case 0	' DOWN
	Case 1	' UP
		If X >= 0 AND X <= lblComboBox.Width AND Y >= 0 AND Y <= lblComboBox.Height Then
			ShowScrollView
		Else
			pnlScreen.RemoveView
		End If
	Case 2	' MOVE
	End Select
	Return True
End Sub

'Initializes and shows the Scrollview
Private Sub ShowScrollView
	lblLeft = lblComboBox.Left
	lblTop = lblComboBox.Top
	
	lblHeight = lblComboBox.Height
	itemHeight = lblHeight * .8
	itemHeight_1 = itemHeight - cBoarderWidth
	
	lblWidth = lblComboBox.Width
	
	cTextSize = lblComboBox.TextSize
	
	pnlScreen.Initialize("pnlScreen")
	cActivity.AddView(pnlScreen, 0, 0, 100%x, 100%y)
	pnlScreen.Color = Colors.Transparent
	
	scvComboBox.Initialize(100)
	Dim Left, Top, Width, Height As Int
	If cParent = cActivity Then
		Left = lblLeft
		Top = lblTop
	Else
		Left = lblLeft + GetParentsLeft(cParent)
		Top = lblTop + GetParentsTop(cParent)
	End If
	
	Height = cNumberVisibleItems * itemHeight
	If 100%y - Top - lblHeight > Height Then
		Top = Top + lblHeight
	Else If Top > Height Then
		Top = Top - Height
	Else
		If Top < 50%y Then
			Top = Top + lblHeight
			Height = Floor(Top / itemHeight) * itemHeight		
		Else
			Top = Top - Height
			Height = Floor((100%y - Top - lblHeight) / itemHeight) * itemHeight		
		End If
	End If
	
	Left = Left + 8dip
	Width = lblWidth - 16dip
	itemWidth = Width - 2 * cBoarderWidth
	itemLeft = cBoarderWidth

	pnlScreen.AddView(scvComboBox, Left, Top, Width, Height)
	scvComboBox.Panel.Color = cBackgroundColor
	scvComboBox.Color = cBackgroundColor
	
	FillScrollView
	
	scvComboBox.Panel.Height = lstComboBox.Size * itemHeight
	If scvComboBox.Panel.Height < scvComboBox.Height Then
		scvComboBox.Height = scvComboBox.Panel.Height
	Else
		scvComboBox.Height = cNumberVisibleItems * itemHeight
	End If
	
	CallSubDelayed2(Me, "ScrollTo", cSelectedIndex * itemHeight)
End Sub

Private Sub ScrollTo(Position As Int)
	Dim jobj = scvComboBox As JavaObject
	jobj.RunMethod("scrollTo", Array As Object (0, cSelectedIndex * itemHeight))
End Sub

Private Sub FillScrollView
	Dim i As Int
	
	For i = 0 To lstComboBox.Size - 1
		Dim lbl As Label
		
		lbl.Initialize("lblItem")
		itemWidth = lblComboBox.Width - 2 * cBoarderWidth
		scvComboBox.Panel.AddView(lbl, itemLeft, i * itemHeight, itemWidth, itemHeight_1)
		lbl.Gravity = Gravity.CENTER_VERTICAL
		lbl.Color = cItemColor
		SetPadding(lbl, 0.5 * cTextSize * 100dip / 100, 1dip, 0.5 * cTextSize * 100dip / 100, 1dip)
		lbl.Text = lstComboBox.Get(i)
		lbl.Tag = i
		lbl.TextColor = cTextColor
		lbl.Color = cItemColor
		lbl.TextSize = cTextSize
	Next
	
	If cSelectedIndex >= 0 Then
		lbl = scvComboBox.Panel.GetView(cSelectedIndex)
		lbl.Color = cSelectedItemColor
		lbl.TextColor = cSelectedTextColor
	End If
	
	If MultiSelectList.Size > 0 Then
		For i = 0 To MultiSelectList.Size - 1
			lbl = scvComboBox.Panel.GetView(i)
			lbl.Color = cSelectedItemColor
			lbl.TextColor = cSelectedTextColor
		Next
	End If
End Sub

'Adds an item at the end of the ComboBox
Public Sub Add(Item As String)
	lstComboBox.Add(Item)
End Sub

'Returns the size of the ComboBox
Public Sub getSize As Int
	Return lstComboBox.Size
End Sub

Public Sub getLeft As Int
	Return lblComboBox.Left
End Sub

'Gets or sets the view's left position.
Public Sub setLeft(Left As Int)
	lblComboBox.Left = Left
End Sub

Public Sub getTop As Int
	Return lblComboBox.Top
End Sub

'Gets or sets the view's top position.
Public Sub setTop(Top As Int)
	lblComboBox.Top = Top
End Sub

Public Sub getWidth As Int
	Return lblComboBox.Width
End Sub

'Gets or sets the view's width.
Public Sub setWidth(Width As Int)
	lblComboBox.Width = Width
End Sub

Public Sub getHeight As Int
	Return lblComboBox.Height
End Sub

'Gets or sets the view's height.
Public Sub setHeight(Height As Int)
	lblComboBox.Height = Height
End Sub

Public Sub getSelectedIndex As Int
	Return cSelectedIndex
End Sub

'Gets or sets the index of the selected item. Returns -1 if no item is selected.
Public Sub setSelectedIndex(Index As Int)
	cSelectedIndex = Index
	
	If cSelectedIndex = -1 Then
		Return
	End If
	
	cSelectedItem = lstComboBox.Get(cSelectedIndex)
	
	lblComboBox.Text = lstComboBox.Get(Index)
	
	If cMultiSelect = True Then
		MultiSelectList.Add(Index)
	End If
End Sub

'Returns the value of the selected item, empty string if no selection.
Public Sub getSelectedItem As String
	Return cSelectedItem
End Sub

Public Sub getTextSize As Float
	Return cTextSize
End Sub

'Gets or sets the text size.
Public Sub setTextSize(TextSize As Float)
	cTextSize = TextSize
	lblComboBox.TextSize = cTextSize
End Sub

Public Sub getSelectedItemColor As Int
	Return cSelectedItemColor
End Sub

'Gets or sets the selected item color.
Public Sub setSelectedItemColor(SelectedItemColor As Int)
	cSelectedItemColor = SelectedItemColor
End Sub

Public Sub getSelectedTextColor As Int
	Return cSelectedTextColor
End Sub

'Gets or sets the selected text color.
Public Sub setSelectedTextColor(SelectedTextColor As Int)
	cSelectedTextColor = SelectedTextColor
End Sub

Public Sub getItemColor As Int
	Return cItemColor
End Sub

'Gets or sets the item color.
Public Sub setItemColor(ItemColor As Int)
	cItemColor = ItemColor
End Sub

Public Sub getTextColor As Int
	Return cTextColor
End Sub

'Gets or sets the text color.
Public Sub setTextColor(TextColor As Int)
	cTextColor = TextColor
'	lblComboBox.TextColor = cTextColor
End Sub

Public Sub getNumberVisibleItems As Int
	Return cNumberVisibleItems
End Sub

'Gets or sets the text number of visible items.
Public Sub setNumberVisibleItems(NumberVisibleItems As Int)
	cNumberVisibleItems = NumberVisibleItems
End Sub

Public Sub getMultiSelect As Boolean
	Return cMultiSelect
End Sub

'Gets or sets the multi select option.
Public Sub setMultiSelect(MultiSelect As Boolean)
	cMultiSelect = MultiSelect
End Sub

Public Sub getMaxNumberOfSelections As Int
	Return cMaxNumberOfSelections
End Sub

'Gest or sets the max number of selectable items.
Public Sub setMaxNumberOfSelections(MaxNumberOfSelections As Int)
	cMaxNumberOfSelections = MaxNumberOfSelections
End Sub

'Gets the item in the specified index. The item is not removed from the ComboBox.
Public Sub GetItem(Index As Int) As String
	Return lstComboBox.Get(Index)
End Sub

'Gets or sets the Enabled property.
Public Sub setEnabled(Enabled As Boolean)
	lblComboBox.Enabled = Enabled
End Sub

Public Sub getEnabled As Boolean
	Return lblComboBox.Enabled
End Sub

'Gets or sets the Visible property.
Public Sub setVisible(Visible As Boolean)
	lblComboBox.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return lblComboBox.Visible
End Sub

'Replaces the current item in the specified index with the new item.
Public Sub SetItem(Index As Int, Item As String)
	lstComboBox.Set(Index, Item)
	If Index = cSelectedIndex Then
		lblComboBox.Text = Item
	End If
End Sub

'Returns the index of the specified item, or -1 if it was not found.
Public Sub IndexOf(Item As String) As Int
	Return lstComboBox.IndexOf(Item)
End Sub

'Inserts the specified Item In the specified index. 
'As a result all items with index larger then the specified index are shifted.
Public Sub InsertAt(Index As Int, Item As String)
	Dim i, j As Int
	
	lstComboBox.InsertAt(Index, Item)
	
	If cMultiSelect = False Then
		If cSelectedIndex >= Index Then
			cSelectedIndex = cSelectedIndex + 1
		End If
	Else
		For i = 0 To MultiSelectList.Size - 1
			j = MultiSelectList.Get(i)
			If j >= Index Then
				j = j + 1
				MultiSelectList.Set(i, j)
			End If
		Next
	End If
End Sub

'Removes the ComboBox from the parent view.
Public Sub RemoveView
	lblComboBox.RemoveView
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	Dim i, j As Int
	
	lstComboBox.RemoveAt(Index)
	
	If cMultiSelect = False Then
		If cSelectedIndex = Index Then
			cSelectedIndex = -1
			cSelectedItem = ""
			lblComboBox.Text = ""
		Else If cSelectedIndex > Index Then
			cSelectedIndex = cSelectedIndex - 1
		End If
	Else
		j = MultiSelectList.IndexOf(Index)
		If j >= 0 Then
			MultiSelectList.RemoveAt(j)
		End If
		For i = 0 To MultiSelectList.Size - 1
			j = MultiSelectList.Get(i)
			If j > Index Then
				j = j - 1
				MultiSelectList.Set(i, j)
			End If
		Next
	End If
End Sub

'Removes all the items from the ComboBox
Public Sub Clear
	lstComboBox.Clear
	MultiSelectList.Clear
End Sub

'Bings the ComboBox in front. 
Public Sub setBringToFront
	lblComboBox.BringToFront
End Sub

'Sends the ComboBox to the back.
Public Sub setSendToBack
	lblComboBox.SendToBack
End Sub
